/*
  Programme écrit par Silicium628
  ce logiciel est libre et open source

  */
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>
#include <QMessageBox>
#include <QDir>
#include <QFileDialog>
#include <QStringList>
#include <QTextStream>

#include "math.h"

QString version = "1.9";

#define MIN 0
#define MAX 1

QColor couleur_ecran = QColor::fromRgb(50, 50, 50, 255);
QColor couleur_cadre = QColor::fromRgb(255, 255, 255, 255);
QColor couleur_grille = QColor::fromRgb(150, 150, 150, 150);
QColor couleur_trace = QColor::fromRgb(0, 150, 0, 255);
QColor couleur_texte = QColor::fromRgb(255, 255, 255, 255);
QColor couleur_date = QColor::fromRgb(0, 100, 0, 255);

QColor couleur_tiret1 = QColor::fromRgb(0, 100, 100, 255); // cyan
QColor couleur_tiret2 = QColor::fromRgb(100, 100, 100, 255); // gris
QColor couleur_tiret3 = QColor::fromRgb(33, 181, 55, 255); //152, 255, 152, 255
QColor couleur_tiret4 = QColor::fromRgb(255, 0, 0, 255); // rouge

QColor couleur_index = QColor::fromRgb(255, 255, 100, 255);

QPen pen_cadre(couleur_cadre, 1, Qt::SolidLine);
QPen pen_grille(couleur_grille, 1, Qt::SolidLine);
QPen pen_trace(couleur_trace, 1, Qt::SolidLine);
QPen pen_texte(couleur_texte, 1, Qt::SolidLine);
QPen pen_date(couleur_date, 1, Qt::SolidLine);
QPen pen_tiret1(couleur_tiret1, 1, Qt::SolidLine);
QPen pen_tiret2(couleur_tiret2, 1, Qt::SolidLine);
QPen pen_tiret3(couleur_tiret3, 1, Qt::SolidLine);
QPen pen_tiret4(couleur_tiret4, 1, Qt::SolidLine);
QPen pen_index(couleur_index, 1, Qt::SolidLine);


QString nom_fichier_in="";
QStringList liste1;
QStringList liste_mois;

QList<Enrt> liste_enr;
QList<Enrt_min_max> liste_min_max;

Enrt enr_i;
Enrt memo_enr_i;


//date du début de la prise en compte des mesures
QDate d00;
QTime t00;
QDateTime dt00;

//date de la première mesure
QDate d0;
QTime t0;
QDateTime dt0;

//date flotante pour balayage de la plage
QDate d1;
QTime t1;
QDateTime dt1;
QDateTime memo_dt1;

QDateTime dt_debut_affi;

int jour1=1;


int num_enr0;

int num_out=0;

int GV1_x0 = 10;
int GV1_y0 = 220;
int GV1_dx = 1570;
int GV1_dy = 650;

int nb_enr_affi; // nb d'enregistrements à afficher
char type_i; // = 'j' .. 's' .. 'm' .. '6' .. 'a' .. '2'
int echelle=1;

int x_offset = 40;  // pour faire coincider la grille pré-calculée avec l'affichage de la courbe

int n_offset; // pour décaller la zone à afficher dans l'ensemble des enregistrements

int annee_affi=2020;
int mois_affi=1;
int nb_de_jours;;


int fichier_OK =0;




MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)

{

    setupUi(this);
    setWindowTitle("Traceur Meteo " + version);
    setGeometry(0,0,1600,995);

// scene 1

    scene1 = new QGraphicsScene(this);
    scene1->setBackgroundBrush(couleur_ecran);

    graphicsView1->setScene(scene1);
    graphicsView1->setGeometry(GV1_x0, GV1_y0, GV1_dx, GV1_dy); // POSITION et dimensions de l'écran

    groupe_grille = new QGraphicsItemGroup();
    groupe_trace = new QGraphicsItemGroup();
    groupe_texte = new QGraphicsItemGroup();

    scene1->addItem(groupe_grille);
    scene1->addItem(groupe_trace);
    scene1->addItem(groupe_texte);

// scene 2

    scene2 = new QGraphicsScene(this);
    scene2->setBackgroundBrush(couleur_ecran);
    graphicsView2->setScene(scene2);
    graphicsView2->setGeometry(10, 870, 1571, 20); // rectangle mince horizontal en bas

    groupe_index = new QGraphicsItemGroup();
    groupe_data_presentes = new QGraphicsItemGroup();

    scene2->addItem(groupe_data_presentes);
    scene2->addItem(groupe_index);

    QStringList liste_entetes2;
    liste_entetes2 <<"T°C"<<"an"<<"mois"<<"jour"<<"heure"<<"minute"<<"QDate"<<"JulianDay"<< "delta t (s)";
    liste_mois << "janvier"<< "février"<< "mars"<< "avril"<< "mai"<< "juin"
               << "juillet"<< "août"<< "septembre"<< "octobre"<< "novembre"<< "décembre";
    tableWidget_2->setHorizontalHeaderLabels (liste_entetes2);
    //on_spinBox_2_valueChanged(1);

//date du début de la prise en compte des mesures
    etiquette2(5, 0, "01/01/2021");
    d00.setDate(2021, 1, 1);
    t00.setHMS(0,0,0);
    dt00.setDate(d00);
    dt00.setTime(t00);

}




MainWindow::~MainWindow()
{

}


void MainWindow::effacer_trace()
{
    foreach( QGraphicsItem *item, scene1->items( groupe_trace->boundingRect() ) )
    {
        if( item->group() == groupe_trace )  { delete item; }
    }
}



void MainWindow::effacer_grille()
{
    foreach( QGraphicsItem *item, scene1->items( groupe_grille->boundingRect() ) )
    {
        if( item->group() == groupe_grille )  { delete item; }
    }
}


void MainWindow::effacer_texte()
{

    foreach( QGraphicsItem *item, scene1->items( groupe_texte->boundingRect() ) )
    {
        if( item->group() == groupe_texte )  { delete item; }
    }
}


void MainWindow::effacer_tout()
{
    effacer_trace();
    effacer_grille();
    effacer_texte();
}


void MainWindow::effacer_index()
{
    foreach( QGraphicsItem *item, scene2->items( groupe_index->boundingRect() ) )
    {
        if( item->group() == groupe_index )  { delete item; }
    }
}


void MainWindow::etiquette1(int x, int y, QString s1) // sur scene1
{
    textItem1 = new QGraphicsSimpleTextItem(s1);
    QBrush brush1;
    brush1.setStyle(Qt::SolidPattern);
    brush1.setColor("#FFFFFF");
    //if (Ti > 0){brush1.setColor("#FF4400");}
    textItem1->setBrush(brush1);
    textItem1->setPos(x+5, y-5);
    groupe_texte->addToGroup(textItem1);
}


void MainWindow::etiquette2(int x, int y, QString s1) // sur scene2
{
    textItem1 = new QGraphicsSimpleTextItem(s1);
    QBrush brush1;
    brush1.setStyle(Qt::SolidPattern);
    brush1.setColor("#0055FF");
    //if (Ti > 0){brush1.setColor("#FF4400");}
    textItem1->setBrush(brush1);
    textItem1->setPos(x+5, y-5);
    scene2->addItem(textItem1);
}


void MainWindow::determine_nb_de_jours()
{
    nb_de_jours =10; // à priori

    if(type_i=='j') {nb_de_jours = 1;}
    if(type_i=='s') {nb_de_jours = 8;}
    if(type_i=='m')
    {
        if (mois_affi==1) {nb_de_jours = 31;}
        if (mois_affi==2) {nb_de_jours = 28;}
        if (mois_affi==3) {nb_de_jours = 31;}
        if (mois_affi==4) {nb_de_jours = 30;}
        if (mois_affi==5) {nb_de_jours = 31;}
        if (mois_affi==6) {nb_de_jours = 30;}
        if (mois_affi==7) {nb_de_jours = 31;}
        if (mois_affi==8) {nb_de_jours = 31;}
        if (mois_affi==9) {nb_de_jours = 30;}
        if (mois_affi==10) {nb_de_jours = 31;}
        if (mois_affi==11) {nb_de_jours = 30;}
        if (mois_affi==12) {nb_de_jours = 31;}
    }
    if(type_i=='6') {nb_de_jours = 7;} // à voir
    if(type_i=='a') {nb_de_jours = 13;}
    if(type_i=='2') {nb_de_jours = 25;}
}



void MainWindow::affiche_grille()
{
    int x, y, w, h;
    float Ti=-20;

    x=0;
    y=-420;
    w= 1550;
    h=640;

    rectangle1 = new QGraphicsRectItem(x, y, w, h);
    rectangle1->setPen(pen_cadre);
    groupe_grille->addToGroup(rectangle1);


//traits horizontaux
    x=0;
    for(int i=0; i<13; i++)
    {

        y =  - 10 * Ti;
        segment_i = new QGraphicsLineItem(30+x, y, x+1500, y);
        segment_i->setPen(pen_grille);
        groupe_grille->addToGroup(segment_i);

// étiquettes texte
        QString s1;
        s1.setNum(Ti); // température
        etiquette1(x+5, y-5, s1);  // graduation de l'axe vertical des température, à gauche

        Ti += 5.0;

    }

// traits verticaux

    determine_nb_de_jours();

    y=-400;
    for(int i=0; i<nb_de_jours+1; i++)
    {
        if(type_i=='j') {x = x_offset + 7*4.5*48 *i; }
        if(type_i=='s') {x = x_offset + 4*48 *i; }
        if(type_i=='m') {x = x_offset + 48 *i; } // OK pour 1 mois ; 48*30mn = 24h
        if(type_i=='6') {x = x_offset + 5*48 *i; } // à voir
        if(type_i=='a') {x = x_offset + 2*48 *i; }
        if(type_i=='2') {x = 0; }

        if (type_i == 'm')
        {
            segment_i = new QGraphicsLineItem(x, y, x, y+600);
            segment_i->setPen(pen_grille);
            groupe_grille->addToGroup(segment_i);

            if ( (jour1 + i) <= nb_de_jours)
            {
                QString s1;
                s1.setNum(jour1 + i);
                etiquette1(x, 150, s1);
            }
        }
    }
    scene1->addItem(groupe_grille);
}


void engendre_liste_min_max()
{
    float T, T_min, T_max;
    int n_max = liste_enr.length();
    int a, m, j, h;
    int fin_de_journee =0;
    Enrt enr_i;
    Enrt_min_max enr_min_max_i;
    T_min =  100;
    T_max = -100;

    for(int n=0; n<n_max; n++)
    {
        a=liste_enr[n].annee;
        m=liste_enr[n].mois;
        j=liste_enr[n].jour;
        h=liste_enr[n].heure;

        if ((h>=1) && (h<2) ) {fin_de_journee = 0; T_min = 100;  T_max = -100;  } // départ pour le jour suivant
// en principe le minimum se situe vers 5h du mat et le maximum vers 16h

        T=liste_enr[n].temperature;
        if (T < T_min) {T_min = T;}
        if (T > T_max) {T_max = T;}

        if (fin_de_journee == 0)
        {
            if (h>=20) //  '>=' et pas '==' parce que l'enr exact '20h00' peut manquer
            {
                fin_de_journee=1; // pour ne plus repasser ici

                enr_min_max_i.annee=a;
                enr_min_max_i.mois=m;
                enr_min_max_i.jour=j;
                enr_min_max_i.temperature_min = T_min;
                enr_min_max_i.temperature_max = T_max;
                liste_min_max << enr_min_max_i;  // on enregistre
            }
        }
    }
}




int MainWindow::determine_d0()
// premier 1er d'un mois dans des enregistrements (qui démarrent éventuellement en cours de mois)
{
    int n=1;
    int trouve =0;
    int a, m, j, h, mi;

    while ( (trouve == 0) && (n < (liste_enr.length() )))  //- 1440) ) )
    {
        a=liste_enr[n].annee;
        m=liste_enr[n].mois;
        j=liste_enr[n].jour;
        h=liste_enr[n].heure;
        mi=liste_enr[n].minute;

        d0.setDate(a, m, j);
        t0.setHMS(h,mi,0);

        dt0.setDate(d0);
        dt0.setTime(t0);

        //if((m==mois_affi) && (j==1) && (h==0) && (mi==0)) {trouve=1;}
        if(  (a==annee_affi) &&  (m==mois_affi) && (j==jour1) && (h==0) && (mi==0)) { trouve=1; }
        n++;
    }
    if ( (trouve == 1) && (n>1) )
    {
        num_enr0 = n-1;
        QString s1;
        s1.setNum(n);
        lineEdit_3->setText(s1);
        return 0;   // OK
    }
    else {return 1;} // 1 erreur (pas trouvé)
}


void MainWindow::affiche_index(QDateTime dt_i)
{
// indique la partie affichée, par un petit rectangle bleu sur la barre horizontale du bas
    qint64 delta_t;
    int x, dx;
    dx=1;

    if (type_i == 's'){dx=7;}
    if (type_i == 'm'){dx=28;}
    if (type_i == '6'){dx=28*6;}
    if (type_i == 'a'){dx=28*12;}

    delta_t = (dt00 .msecsTo(dt_i)/1000); // (en s) intervalle de temps entre les deux QDateTime
    delta_t /= 1800; //(en demi-heures)

    x = 0 + delta_t/50;

    rectangle1 = new QGraphicsRectItem(x, -1, dx, 10);
    rectangle1->setPen(pen_index);
    groupe_index->addToGroup(rectangle1);
    scene2->addItem(groupe_index);
}



void MainWindow::tracer_data_presentes() // dans la barre d'index horizontale en bas
{
    qint64 delta_t;
    float x=0;

    int nb_enr_dispo = liste_enr.length()-2;

    for(int n=1; n<nb_enr_dispo; n+=100) // +100 pour gagner en rapidité !
    {
        int a, m, j, h, mi;
        a=liste_enr[n].annee;
        m=liste_enr[n].mois;
        j=liste_enr[n].jour;
        h=liste_enr[n].heure;
        mi=liste_enr[n].minute;

//date flotante pour balayage de la plage
        d1.setDate(a, m, j);
        t1.setHMS(h,mi,0);
        dt1.setDate(d1);
        dt1.setTime(t1);

// calcul intervalle depuis la date du début de la prise en compte des mesures
        delta_t = (dt00.msecsTo(dt1)/1000); // (en s) intervalle de temps entre les deux QDateTime
        delta_t /= 1800; //(en demi-heures)

        // transcription [durée] -> [longueur]
        x = 0 + delta_t/50;

        segment_i = new QGraphicsLineItem(x, 0, x, 8);
        segment_i->setPen(pen_tiret3);

        groupe_data_presentes->addToGroup(segment_i);
        scene2->addItem(groupe_data_presentes);
    }
}


QColor couleur_de_temperature(float i)
{
    float xr,xv,xb;
    float r,v,b;
    QColor c1;

    i = 35-i;
    i /= 8;
    xr=(i+12)/10.0;		r=140.0+120.0*sin(xr); if (r<0) {r=0;}  if (r>255) {r=255;}
    xv=(i+54)/10.0;		v=130.0+150.0*sin(xv); if (v<0) {v=0;}  if (v>255) {v=255;};
    xb=(i+38)/10.0;		b=100.0+150.0*sin(xb); if (b<0) {b=0;}  if (b>255) {b=255;};

    c1.setRgb(b,v,r);
    return c1;
}



void MainWindow::tracer_courbe()
{
    qint64 delta_t;

    //float temperature_i;
    float memo_temperature_i = 0;
    int glitch =0;
    int n2;

   // effacer_index();

    if (fichier_OK == 0) {return;}

    determine_nb_de_jours();

    if(type_i=='j') {nb_enr_affi = 48; spinBox_jour->setHidden(0);}
    if(type_i=='s') {nb_enr_affi = 336; spinBox_jour->setHidden(0);}
    if(type_i=='m') {nb_enr_affi = 48 * (nb_de_jours-1); spinBox_jour->setHidden(0);}
    if(type_i=='6') {nb_enr_affi = 8766; spinBox_jour->setValue(1); spinBox_jour->setHidden(1);}
    if(type_i=='a') {nb_enr_affi = 17532; spinBox_jour->setValue(1); spinBox_jour->setHidden(1);}
    if(type_i=='2') {nb_enr_affi = 35064; spinBox_jour->setValue(1); spinBox_jour->setHidden(1);}

    float x=0;
    float y=0;
    float memo_x, memo_y;
    int n, p;
    int n_max;

    effacer_tout();

    int nb_enr_dispo = liste_enr.length()-2;

    p=0;

    // on va afficher  'nb_enr_affi' enregistrements
    n_max = nb_enr_affi;
    if(n_max > (nb_enr_dispo-num_enr0)) {n_max = nb_enr_dispo -num_enr0 -1;}


    for(n=1; n<n_max; n++)
    {
//qDebug()<< n;
        n2 = num_enr0 + n;

        // on va donc considérer la liste comme une collections de points pas forcément équidistants dans le temps
        // et on va les placer sur l'axe horizontal en fontion de leur position réelle dans le temps
        // c'est simple puisque que le type 'QDate' permet de connaitre cette position temporelle

        int a, m, j, h, mi;

// lecture de la date de chaque enregistrement
        a=liste_enr[n2].annee;
        m=liste_enr[n2].mois;
        j=liste_enr[n2].jour;
        h=liste_enr[n2].heure;
        mi=liste_enr[n2].minute;

//constitution de la date flotante pour balayage de la plage
        d1.setDate(a, m, j);
        t1.setHMS(h,mi,0);
        dt1.setDate(d1);
        dt1.setTime(t1);

// mémorisation pour afficher le petit rectangle en bas
        if (n==1) {dt_debut_affi = dt1;} // date du début de l'affichage

// calcul intervalle depuis la date de la première mesure
        delta_t = (dt0.msecsTo(dt1)/1000); // (en s)
        delta_t /= 1800; //(en demi-heures)

        memo_x = x;
        memo_y = y;

        if(type_i=='j')
        {
            x = 45 + x_offset + 16* delta_t;
            if ( (h==12)&&(mi==0))
            {
                QString s1, s2, s3, st;
                s1.setNum(j);  s2.setNum(m); s3.setNum(a);
                st = s1 + "/"+ s2 + "/" + s3;
                etiquette1(x-30, -200, st); // date affichée en haut
            }
        }
        if(type_i=='s')
        {
            // transcription [durée] -> [longueur]
            x = 45 + 4*delta_t;

            if((h==12) && (mi==0))
            {
                QString s1, s2, s3, st;
                s1.setNum(j);  s2.setNum(m); s3.setNum(a);
                st = s1 + "/"+ s2 + "/" + s3;
                etiquette1(x-30, 200, st); // dates affichées en bas sur l'axe x
            }
        }
        if(type_i=='m')  { x = x_offset + delta_t; }
        if(type_i=='6')  { x = x_offset + delta_t/6; }
        if(type_i=='a')
        {
            x = x_offset + delta_t/12;
            if( (j==1) && (h==0)  )
            {
                QString s1, s2, st;
                s1.setNum(m);  s2.setNum(a);
                st = s1 + "/"+ s2;
                etiquette1(x+30, -400, st); // dates affichées en haut
            }
        }
        if(type_i=='2') { x = x_offset + delta_t/24; }


        float temperature_i = liste_enr[n2].temperature;
        glitch =0;
        if ((abs(temperature_i - memo_temperature_i)) > 10.0 ) { glitch = 1;} // dans ce cas ne pas afficher la valeur foireuse

        y = - 10 * temperature_i;

        memo_temperature_i = temperature_i;
        p++; // nb de passages

        if ((p > 1 ) && (glitch ==0)) // pour éviter de tracer le 1er segment dont un seul point est défini
        {
            if (abs(memo_x - x)<20)
            {
// TRACE LA COURBE DE TEMPERATURE
                segment_i = new QGraphicsLineItem(memo_x, memo_y, x, y);
                QColor coul_1=couleur_de_temperature(y);
                pen_trace.setColor(coul_1);
                segment_i->setPen(pen_trace);
                groupe_trace->addToGroup(segment_i);

                //segment_i->setLine(memo_x+5, memo_y, x+5, y);
                //groupe_trace->addToGroup(segment_i);
            }
        }

// traits verticaux
        if ((h==0)&&(mi==0))
        {
            segment_i = new QGraphicsLineItem( x, -20, x, 20);
            segment_i->setPen(pen_tiret1); // indique minuit (séparation entre les jours)
            groupe_trace->addToGroup(segment_i);

            if (j==1)
            {
                segment_i = new QGraphicsLineItem( x, -400, x, 200);
                segment_i->setPen(pen_tiret2); // indique minuit (séparation entre les jours)
                groupe_trace->addToGroup(segment_i);
            }
        }

        if((type_i=='j') && (mi==0))
        {
            segment_i = new QGraphicsLineItem( x, -400, x, 200);
            if (h==12) {segment_i->setPen(pen_tiret4);} else {segment_i->setPen(pen_tiret2);}
            groupe_trace->addToGroup(segment_i); // indique les heures (midi = rouge)

            QString s1;
            s1.setNum(h);
            etiquette1(x-10, 205, s1); // dates affichées en bas sur l'axe x
        }

        if((type_i=='6') && (j==1)&& (h==0))
        {
            segment_i = new QGraphicsLineItem( x, -400, x, 200);
            if (h==12) {segment_i->setPen(pen_tiret4);} else {segment_i->setPen(pen_tiret2);}
            groupe_trace->addToGroup(segment_i); // indique les heures (midi = rouge)

            QString s1;
            //s1.setNum(m);
            s1 = liste_mois[m-1];
            etiquette1(x+50, 180, s1); // dates affichées en bas sur l'axe x
        }
    }

    scene1->addItem(groupe_trace);

    affiche_grille();
}



void MainWindow::tracer_min_max(int plein)
{
   qint64 delta_t;

   float x=0;
   float y1=0;
   float y2=0;
   float memo_tpr_min =0;
   float memo_tpr_max =0;
   float memo_x, memo_y1, memo_y2;

   int n, n2, p;

   int num_enr_min0;
   int n_max;
   int glitch =0;

   determine_nb_de_jours();

  // if(type_i=='j') {nb_enr_affi = 48; spinBox_jour->setHidden(0);}
  // if(type_i=='s') {nb_enr_affi = 336; spinBox_jour->setHidden(0);}
   if(type_i=='m') {nb_enr_affi = nb_de_jours-1; spinBox_jour->setHidden(0);}
  // if(type_i=='6') {nb_enr_affi = 8766; spinBox_jour->setValue(1); spinBox_jour->setHidden(1);}
  // if(type_i=='a') {nb_enr_affi = 17532; spinBox_jour->setValue(1); spinBox_jour->setHidden(1);}
  // if(type_i=='2') {nb_enr_affi = 35064; spinBox_jour->setValue(1); spinBox_jour->setHidden(1);}


   int nb_enr_dispo = liste_min_max.length()-2;
   num_enr_min0 = (num_enr0 / 47) -5;

// qDebug() << "num_enr_min0" << num_enr_min0;

   p=0;

   // on va afficher  'nb_enr_affi' enregistrements
   //n_max = nb_enr_affi;
   n_max =40;

   if(n_max > (nb_enr_dispo - num_enr_min0)) {n_max = nb_enr_dispo-num_enr_min0 -1;}

   for(n=1; n<n_max; n++)
   {
       n2 =num_enr_min0 + n;
       int a, m, j;

// lecture de la date de chaque enregistrement
       a=liste_min_max[n2].annee;
       m=liste_min_max[n2].mois;
       j=liste_min_max[n2].jour;

//constitution de la date flotante pour balayage de la plage
       d1.setDate(a, m, j);
       t1.setHMS(14,0,0);
       dt1.setDate(d1);
       dt1.setTime(t1);

       delta_t = (dt0.msecsTo(dt1)/1000); // (en s)
       delta_t /= 1800; //(en demi-heures)

       memo_x = x;
       memo_y1 = y1;
       memo_y2 = y2;

       if(type_i=='m')
       {
           x = x_offset + delta_t;
       }

       float tpr_min =0;
       float tpr_max =0;

       tpr_min = liste_min_max[n2].temperature_min;
       tpr_max = liste_min_max[n2].temperature_max;

// lorsque l'on coupe l'alimentation de la station météo, par exemple pour la modifier (hard ou soft) il s'ensuit
// des manques de données et des 'sauts' de température dans la liste des enregistrements, des 'glitch'
       glitch =0; // à priori
      // if ((abs(tpr_max - memo_tpr_max)) > 10.0 ) { glitch = 1;}
      // if ((abs(tpr_min - memo_tpr_min)) > 10.0 ) { glitch = 1;}

       y1 = - 10 * tpr_min;
       y2 = - 10 * tpr_max;

       p++; // nb de passages

       memo_tpr_min = tpr_min;
       memo_tpr_max = tpr_max;

       if ((p > 1 ) && (glitch ==0))  // 'p' pour éviter de tracer le 1er segment dont un seul point est défini
       {

           if(plein == 1)
           {
// remplissage entre les 2 courbes mini-maxi, avec couche alpha
               QPolygonF poly1;
               poly1 << QPointF(memo_x, memo_y1) << QPointF(x, y1) << QPointF(x, y2) << QPointF(memo_x, memo_y2);
               polygone1 = new QGraphicsPolygonItem(poly1);

               QBrush brush1;
               QColor couleur_plein = QColor::fromRgb(255, 255, 100, 50);
               brush1.setColor(couleur_plein);

               brush1.setStyle(Qt::SolidPattern);
               polygone1->setBrush(brush1);

               QColor couleur_trait = QColor::fromRgb(0, 0, 0, 0);
               QPen pen1;
               pen1.setColor(couleur_trait);
               polygone1->setPen(pen1);

               groupe_trace->addToGroup(polygone1);
           }

// TRACE LA COURBE DE TEMPERATURE MIN
           //segment_i = new QGraphicsLineItem(memo_x, memo_y, x, y);
           segment_i = new QGraphicsLineItem(memo_x, memo_y1, x, y1);
           pen_trace.setColor("#0055FF");
           segment_i->setPen(pen_trace);
           groupe_trace->addToGroup(segment_i);

// TRACE LA COURBE DE TEMPERATURE MAX
           segment_i = new QGraphicsLineItem(memo_x, memo_y2, x, y2);
           pen_trace.setColor("#FF5500");
           segment_i->setPen(pen_trace);
           groupe_trace->addToGroup(segment_i);
       }
   }
}




void MainWindow::Extraire_1_Enr(QString ligne_i)
{
    int annee, mois, jour, heure, minute;
    QString s1, s2;
    int p1;

    int Tdeg;
    float T_float;
    QDate d1;
    QTime t1;
    QDateTime dt1;
    qint64 JDay;
    qint64 delta_t;


 //  "2022-08-03 [ 14:30 ] ; T(ext)=3063 ; T(int)=2976 ; H=28 ; P=1015"
    //enr_i.dateTime =
//
//    //d1.fromString(s1, Qt::ISODate);
//    d1.fromString(s1, "yyyy-MM-dd");

    int R=tableWidget_2->rowCount();
    tableWidget_2->setRowCount(R+1);  //ajoute une nouvelle ligne au tableau

    p1 = ligne_i.indexOf("T(ext)=");
    s1 = ligne_i.mid(p1+7, 4);
    Tdeg = s1.toInt();
    T_float = (float)Tdeg - 2730;
    T_float /= 10.0;

    if ((T_float < -30) || (T_float > 50)) {T_float =0;}
    enr_i.temperature = T_float;

    s2.setNum(T_float);
    tableWidget_2->setItem(num_out, 0, new QTableWidgetItem (s2) );


    s1 = ligne_i.left(4);
    tableWidget_2->setItem(num_out, 1, new QTableWidgetItem (s1) );
    annee = s1.toInt();
    enr_i.annee = annee;

    s1 = ligne_i.mid(5, 2);
    tableWidget_2->setItem(num_out, 2, new QTableWidgetItem (s1) );
    mois = s1.toInt();
    enr_i.mois = mois;

    s1 = ligne_i.mid(8, 2);
    tableWidget_2->setItem(num_out, 3, new QTableWidgetItem (s1) );
    jour = s1.toInt();
    enr_i.jour = jour;

//  "2022-08-03 [ 14:30 ] ; T(ext)=3063 ; T(int)=2976 ; H=28 ; P=1015"

    p1 = ligne_i.indexOf("[ ");
    s1 = ligne_i.mid(p1+2, 2);
    tableWidget_2->setItem(num_out, 4, new QTableWidgetItem (s1) );
    heure = s1.toInt();
    enr_i.heure = heure;

    s1 = ligne_i.mid(p1+5, 2);
    tableWidget_2->setItem(num_out, 5, new QTableWidgetItem (s1) );
    minute = s1.toInt();
    enr_i.minute = minute;

    t1.setHMS(heure, minute, 0); //QTime
    dt1.setTime(t1); //QDateTime

    d1.setDate(annee, mois, jour); //QDate
    dt1.setDate(d1); //QDateTime

    delta_t = memo_dt1.msecsTo(dt1) / 1000; // calcule l'intervalle de temps entre les deux QDateTime

    s1.setNum(delta_t);
    tableWidget_2->setItem(num_out, 8, new QTableWidgetItem (s1) );

    memo_dt1 = dt1;

    s1 = d1.toString();
    tableWidget_2->setItem(num_out, 6, new QTableWidgetItem (s1) );

    JDay = d1.toJulianDay();
    enr_i.JulianDay = JDay;
    s1.setNum(JDay);
    tableWidget_2->setItem(num_out, 7, new QTableWidgetItem (s1) );


    memo_enr_i= enr_i;
    liste_enr << enr_i;
    num_out++;

}


int MainWindow::openFile()
{
    QString ligne_i, str1;

    fichier_OK = 0;
    liste1.clear();
    liste_enr.clear();
    liste_min_max.clear();
    //liste_chaines_out.clear();

    nom_fichier_in = QFileDialog::getOpenFileName(this, tr("Ouvrir Fichier..."),
    QString(), tr("Fichiers txt (*.txt);;All Files (*)"));
    if (!nom_fichier_in.isEmpty())
    {
        lineEdit_1->setText(nom_fichier_in);
    }

    QFile file1(nom_fichier_in);
    if (!file1.open(QIODevice::ReadOnly | QIODevice::Text)) return 1;
    QTextStream TextStream1(&file1);

    int num_ligne = 0;
    while ( !TextStream1.atEnd() )
    {
        ligne_i = TextStream1.readLine();
        liste1 << ligne_i;
        Extraire_1_Enr(ligne_i);

        num_ligne++;
    }
    file1.close();

    str1.setNum(num_ligne);
    lineEdit_2->setText(str1 + " lignes");

    tableWidget_2->resizeColumnsToContents();
    fichier_OK = 1;

    return 0;
}


void MainWindow::LISTER()
{
    if (!nom_fichier_in.isEmpty())
    {
        QString ligne_i1;
        QString debut_ligne;

        int nb_lignes=liste1.count();
        int num_ligne =0;


        tableWidget_1->clear();
        tableWidget_1->setRowCount(0);

        while((num_ligne < nb_lignes-1) )
        {
            ligne_i1 = liste1[num_ligne];

            int R=tableWidget_1->rowCount();
            tableWidget_1->setRowCount(R+1);  //ajoute une nouvelle ligne au tableau
            tableWidget_1->setItem(num_ligne, 0, new QTableWidgetItem (ligne_i1) );
            num_ligne++;
        }
        tableWidget_1->resizeColumnsToContents();
    }
}


void MainWindow::on_Btn_FICHIER_clicked()
{
    setCursor(Qt::WaitCursor);
    Btn_FICHIER->setStyleSheet("background-color: #FFF396;"); //jaune
    lineEdit_1->clear();
    int result = openFile();
    if (result == 0)
    {

        Btn_FICHIER->setStyleSheet("background-color: #73FF7A;"); // vert
        LISTER();
        determine_d0();
        engendre_liste_min_max();
        type_i='m';
        tous_bt_gris();
        Bt_1mois->setStyleSheet("background-color: #73FF7A;");
        on_spinBox_1_valueChanged(2022);
        mois_affi--;
        on_Bt_mois_plus_clicked();

        tracer_data_presentes();

    }
    else
    {
        Btn_FICHIER->setStyleSheet("background-color: #FF9090;"); //rouge
    }
    setCursor(Qt::ArrowCursor);
}



void MainWindow::on_pushButton_2_clicked()
{
    affiche_grille();
}


//Rappel : dispo : 1 enregistrement toutes les 30 minutes (2 enr/h)

void MainWindow::on_Bt_1jour_clicked()
{
    Bt_1jour->setStyleSheet("background-color: #73FF7A;");
    Bt_1semaine->setStyleSheet("background-color: #F5F5F5;");
    Bt_1mois->setStyleSheet("background-color: #F5F5F5;");
// 1j = 24h -> 24*2 = 48 enr
   // nb_enr_affi = 48;
    type_i='j';
    effacer_index();
    int R = determine_d0();
    if (R==0) { tracer_courbe(); }

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);
}


void MainWindow::tous_bt_gris()
{
    Bt_2ans->setStyleSheet("background-color: #F5F5F5;");
    Bt_1an->setStyleSheet("background-color: #F5F5F5;");
    Bt_6mois->setStyleSheet("background-color: #F5F5F5;");
    Bt_1mois->setStyleSheet("background-color: #F5F5F5;");
    Bt_1jour->setStyleSheet("background-color: #F5F5F5;");
    Bt_1semaine->setStyleSheet("background-color: #F5F5F5;");
}


void MainWindow::on_Bt_1semaine_clicked()
{
    tous_bt_gris();
    Bt_1semaine->setStyleSheet("background-color: #73FF7A;");

// 1 semaine -> 7* 48 = 336 enr
   // nb_enr_affi = 336;
    type_i='s';
    effacer_index();
    int R = determine_d0();
    if (R==0) { tracer_courbe(); }

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);

}


void MainWindow::on_Bt_1mois_clicked()
{
    tous_bt_gris();
    Bt_1mois->setStyleSheet("background-color: #73FF7A;");
    type_i='m';
    effacer_index();
    int R = determine_d0();
    if (R==0) { tracer_courbe(); }

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);

    QString s1;
    s1.setNum(annee_affi);
    QString s2;
    s2=liste_mois[mois_affi-1];
    s2 += " ";
    s2+=s1;
    lineEdit_4->setText(s2);
    etiquette1(100, -370, s2);
}


void MainWindow::on_Bt_6mois_clicked()
{
    tous_bt_gris();
    Bt_6mois->setStyleSheet("background-color: #73FF7A;");

    type_i='6';
    effacer_index();
    int R = determine_d0();
    if (R==0) { tracer_courbe(); }

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);
}


void MainWindow::on_Bt_1an_clicked()
{
    tous_bt_gris();
    Bt_1an->setStyleSheet("background-color: #73FF7A;");
// 365.25 * 48 = 17532 enr
    //nb_enr_affi = 17532;
    type_i='a';
    effacer_index();
    int R = determine_d0();
    if (R==0) { tracer_courbe(); }

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);
}


void MainWindow::on_Bt_2ans_clicked()
{
    tous_bt_gris();
    Bt_2ans->setStyleSheet("background-color: #73FF7A;");
// 730.5 * 48 = 35064 enr
   // nb_enr_affi = 35064;
    type_i='2';

    int R = determine_d0();
    if (R==0) { tracer_courbe(); }

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);
}

void MainWindow::on_Bt_effacer_clicked()
{
    effacer_tout();
}



void MainWindow::on_spinBox_jour_valueChanged(int arg1)
{
    jour1=arg1;
    effacer_index();
    int R = determine_d0();
    if (R==0) { tracer_courbe(); }

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, jour1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);
}


void MainWindow::on_spinBox_1_valueChanged(int arg1)
{
   //effacer_index();
   annee_affi = arg1;
   QString s1;
   s1.setNum(annee_affi);

}


void MainWindow::on_Bt_mois_plus_clicked()
{
    effacer_index();
    mois_affi++;
    if (mois_affi>12)
    {
        mois_affi =1;
        annee_affi ++;
    }

    QString s1;
    s1.setNum(annee_affi);
    //lineEdit_5->setText(s1);
    spinBox_1->setValue(annee_affi);

    effacer_tout();
    int R = determine_d0();
    affiche_grille();

    if (R==0) { tracer_courbe(); } else { QString s1 ="Pas de données depuis cette date"; etiquette1(500, -200, s1); }

    QString s2;
    s2=liste_mois[mois_affi-1];
    s2 += " ";
    s2+=s1;
    lineEdit_4->setText(s2);
    if (type_i == 'm')  { etiquette1(100, -370, s2);}
    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);
}


void MainWindow::on_Bt_mois_moins_clicked()
{
    effacer_index();
    mois_affi--;
    if (mois_affi<1)
    {
        mois_affi =12;
        annee_affi --;
    }
    QString s1=liste_mois[mois_affi-1];
    lineEdit_4->setText(s1);
    s1.setNum(annee_affi);
    //lineEdit_5->setText(s1);
    spinBox_1->setValue(annee_affi);

    effacer_tout();
    int R = determine_d0();
    affiche_grille();
    if (R==0) { tracer_courbe(); } else { QString s1 ="Pas de données depuis cette date"; etiquette1(500, -200, s1); }

    QString s2;
    s2=liste_mois[mois_affi-1];
    s2 += " ";
    s2+=s1;
    lineEdit_4->setText(s2);
    if (type_i == 'm')  { etiquette1(100, -370, s2);}

    QDateTime dti;
    QDate di;
    QTime ti;
    di.setDate(annee_affi, mois_affi, 1);
    ti.setHMS(0,0,0);

    dti.setDate(di);
    dti.setTime(ti);
    affiche_index(dti);
}




void MainWindow::on_pushButton_clicked()
{
    effacer_trace();
    int R = determine_d0();
    on_Bt_1mois_clicked();
    //affiche_grille();
    tracer_min_max(0);
}

void MainWindow::on_pushButton_3_clicked()
{
    affiche_grille();
    int R = determine_d0();
    tracer_min_max(1);
}
